
Figure - Bug #113494
测试 Test-ST # 113421 (New): V4.0功能与专项测试

测试 Test-ST # 113422 (New): V4.0专项--AF专项--monkey测试

【AF】【EVT2】【Monkey】Monkey测试8小时，出现ANR: com.android.systemui
2022-11-01 15:58 - CD Test赵飞

Status: CLOSED Start date: 2022-11-01

Priority: Normal Due date:

Assignee: CD FW-鲁凯峰 % Done: 100%

Category: CD-FW Estimated time: 0.00 hour

Target version: VX1_MCE_FSE_V5.0_20221230

Need_Info: -- Found Version: FlatBuild_HH_VX1_MCE_FSE.M.D.user.01.00.X101.202210290232

Resolution: FIXED Degrated: --

Severity: Normal Verified Version:

Reproducibility: Frequently Fixed Version:

Test Type: Monkey Test Root cause: SystemUI crash

Description

执行命令：

1. adb shell

2. monkey --ignore-crashes --ignore-timeouts --ignore-security-exceptions --monitor-native-crashes --ignore-native-crashes -s 20 --throttle 200

--pct-touch 30 --pct-motion 15 --pct-nav 15 --pct-majornav 15 --pct-syskeys 5 --pct-appswitch 5 --pct-anyevent 5 --ignore-crashes -v -v -v 180000

2>/sdcard/error.txt 1>/sdcard/info.txt

错误日志：

// NOT RESPONDING: com.android.systemui (pid 2081)

ANR in com.android.systemui

PID: 2081

Reason: Input dispatching timed out (c76b002 NotificationShade (server) is not responding. Waited 5002ms for MotionEvent(deviceId=-1,

eventTime=27867239000000, source=0x00001002, displayId=0, action=DOWN, actionButton=0x00000000, flags=0x00000000,

metaState=0x00000000, buttonState=0x00000000, classification=NONE, edgeFlags=0x00000000, xPrecision=1.0, yPrecision=1.0,

xCursorPosition=nan, yCursorPosition=nan, pointers=[0: (2181.0, 506.0)]), policyFlags=0x6b000000)

ErrorId: 9f48d09e-37ac-4149-bef9-2f5a2b0338d6

Frozen: false

Load: 5.8 / 6.14 / 5.36

----- Output from /proc/pressure/memory -----

some avg10=0.00 avg60=0.00 avg300=0.00 total=0

full avg10=0.00 avg60=0.00 avg300=0.00 total=0

----- End output from /proc/pressure/memory -----

CPU usage from 0ms to 14005ms later (2022-10-28 21:20:13.425 to 2022-10-28 21:20:27.430):

  96% 1241/ept_uppertester_v2.0_fse: 84% user + 11% kernel

  31% 1137/system_server: 8.5% user + 22% kernel / faults: 30820 minor

  30% 2081/com.android.systemui: 22% user + 8.1% kernel / faults: 3124 minor

  30% 1231/tlog: 1.4% user + 29% kernel / faults: 1 minor

  26% 1033/surfaceflinger: 11% user + 14% kernel / faults: 1775 minor

  19% 1331/media.codec: 4.4% user + 14% kernel / faults: 10859 minor

  19% 957/vendor.qti.hardware.display.composer-service: 5.4% user + 13% kernel / faults: 111 minor

  18% 1286/mediaserver: 6.5% user + 12% kernel / faults: 1966 minor

  16% 1424/media.swcodec: 4% user + 12% kernel / faults: 7822 minor

  12% 5602/com.android.deskclock: 7.1% user + 5.7% kernel / faults: 3140 minor

  8.2% 1013/audioserver: 2.7% user + 5.5% kernel / faults: 383 minor

...
History

#1 - 2022-11-01 16:02 - CD Test赵飞

- File error.txt added

- File info.txt added

- Assignee set to CD FW 曹覃刚

#2 - 2022-11-08 10:41 - CD FW 曹覃刚

- Status changed from New to ASSIGNED

- Assignee changed from CD FW 曹覃刚 to CD FW-鲁凯峰

请帮忙分析下这个问题

#3 - 2022-11-09 09:52 - CD Test赵飞

- File Tlog&ANR.zip.001 added

- File Tlog&ANR.zip.002 added

- File Tlog&ANR.zip.003 added

11月8号release版本复现此问题

Tlog&ANR目录见附件

#4 - 2022-11-09 14:34 - CD FW 曹覃刚

- Assignee changed from CD FW-鲁凯峰 to CD Test赵飞

Hi 赵飞

附件里的ANR日志，无法打开，无法解压缩

请帮忙重新上传一份，感谢

#5 - 2022-11-10 10:54 - CD Test赵飞

- Assignee changed from CD Test赵飞 to CD FW 曹覃刚

Log已上传至FTP

ftp://cdiot@192.168.87.46/Pre_figure/Test_Log/Bug_113494/Tlog&#38;ANR.zip

#6 - 2022-11-10 19:55 - CD FW-鲁凯峰

- Status changed from ASSIGNED to RESOLVED

- Assignee changed from CD FW 曹覃刚 to CD Test赵飞

- Resolution changed from -- to FIXED

- Root cause set to SystemUI crash

■ Current conclusion

看起来有点像是SystemUI Crash了,导致Hwui绘制异常了

2025-07-04 2/5

ftp://cdiot@192.168.87.46/Pre_figure/Test_Log/Bug_113494/Tlog&#38;ANR.zip


■ My analysis

从trace信息看,nSyncAndDrawFrame出现了异常

"main" prio=5 tid=1 Native  | group="main" sCount=1 ucsCount=0 flags=1 obj=0x717513a8 self=0xb400007c91f25be0  | sysTid=2036 nice=0 cgrp=default sched=0/0

handle=0x7e5b2e04f8  | state=S schedstat=( 1247173349143 1232846138935 2383247 ) utm=76502 stm=48214 core=4 HZ=100  | stack=0x7fe06b7000-0x7fe06b9000

stackSize=8188KB  | held mutexes=

  native: #00 pc 000000000004def0  /apex/com.android.runtime/lib64/bionic/libc.so (syscall+32)

  native: #01 pc 00000000000527bc  /apex/com.android.runtime/lib64/bionic/libc.so (__futex_wait_ex(void volatile*, bool, int, bool, timespec const*)+148)

  native: #02 pc 00000000000b5c50  /apex/com.android.runtime/lib64/bionic/libc.so (pthread_cond_wait+84)

  native: #03 pc 000000000036bff0  /system/lib64/libhwui.so (android::uirenderer::renderthread::DrawFrameTask::postAndWait()+256)

  native: #04 pc 000000000036bebc  /system/lib64/libhwui.so (android::uirenderer::renderthread::RenderProxy::syncAndDrawFrame()+52)

  at android.graphics.HardwareRenderer.nSyncAndDrawFrame(Native method)

  at android.graphics.HardwareRenderer.syncAndDrawFrame(HardwareRenderer.java:456)

出现异常的原因有可能是SystemUI Crash,导致NavigationBar绘制出错引起的

11-08 06:39:54.396  1139  1710 I WindowManager: ANR in NavigationBar0. Reason:b784fa8 NavigationBar0 (server) is not responding. Waited 5001ms for

MotionEvent(deviceId=-1, eventTime=17456610000000, source=0x00001002, displayId=0, action=DOWN, actionButton=0x00000000, flags=0x00000000,

metaState=0x00000000, buttonState=0x00000000, classification=NONE, edgeFlags=0x00000000, xPrecision=1.0, yPrecision=1.0, xCursorPosition=nan,

yCursorPosition=nan, pointers=[0: (122.0, 706.0)]), policyFlags=0x6b000000

SystemUI Crash在另外一个票上已经解决了

https://dev.thundercomm.com/gerrit/c/general/platform/frameworks/base/+/161275

// CRASH: com.android.systemui:screenshot (pid 12924)

// Short Msg: java.lang.IllegalStateException

// Long Msg: java.lang.IllegalStateException: Image is already closed

// Build Label: TC/figure_CN/figure:12/SKQ1.220201.001/1319:userdebug/test-keys

// Build Changelist: 1319

// Build Time: 1667843376000

// java.lang.IllegalStateException: Image is already closed

//     at android.media.Image.throwISEIfImageIsInvalid(Image.java:73)

//     at android.media.ImageReader$SurfaceImage.getHardwareBuffer(ImageReader.java:989)

//     at com.android.systemui.screenshot.ImageTile.<init>(ImageTile.java:57)

//     at com.android.systemui.screenshot.ScrollCaptureController.onCaptureResult(ScrollCaptureController.java:263)

//     at com.android.systemui.screenshot.ScrollCaptureController.lambda$requestNextTile$2(ScrollCaptureController.java:201)

//     at com.android.systemui.screenshot.ScrollCaptureController.$r8$lambda$4sO_sN6742S0RDVb5SN-JLbf7OE(Unknown Source:0)

//     at com.android.systemui.screenshot.ScrollCaptureController$$ExternalSyntheticLambda2.run(Unknown Source:2)

//     at android.os.Handler.handleCallback(Handler.java:938)

//     at android.os.Handler.dispatchMessage(Handler.java:99)

//     at android.os.Looper.loopOnce(Looper.java:201)

//     at android.os.Looper.loop(Looper.java:288)

//     at android.app.ActivityThread.main(ActivityThread.java:7880)

//     at java.lang.reflect.Method.invoke(Native Method)

//     at com.android.internal.os.RuntimeInit$MethodAndArgsCaller.run(RuntimeInit.java:548)

//     at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:1009)

■ Next Action

请在下个版本在验证一下 是否有相同的anr或者crash信息

#7 - 2022-11-14 11:15 - CD Test赵飞

- Status changed from RESOLVED to ASSIGNED

- Assignee changed from CD Test赵飞 to CD FW-鲁凯峰
- % Done changed from 0 to 40

11月11号DB复现此问题1次

错误信息：

// NOT RESPONDING: com.android.systemui (pid 2004)

ANR in com.android.systemui

PID: 2004

Reason: Input dispatching timed out (a65ede4 NotificationShade (server) is not responding. Waited 5001ms for KeyEvent(deviceId=-1,

eventTime=22903022000000, source=0x00000101, displayId=-1, action=DOWN, flags=0x00000008, keyCode=82, scanCode=0, metaState=0x00000000,

repeatCount=0), policyFlags=0x6b000000)

ErrorId: 0ebf202f-ecc2-42dc-af68-df5270158d6e

Frozen: false

Load: 5.62 / 5.64 / 5.99

----- Output from /proc/pressure/memory -----

some avg10=0.00 avg60=0.00 avg300=0.00 total=3469361

full avg10=0.00 avg60=0.00 avg300=0.00 total=1676046

----- End output from /proc/pressure/memory -----

CPU usage from 0ms to 17265ms later (2022-11-11 11:08:12.924 to 2022-11-11 11:08:30.190):

  92% 1232/tlog: 2.8% user + 89% kernel / faults: 4 minor

  91% 1058/sensors.qti: 18% user + 73% kernel

  70% 2004/com.android.systemui: 50% user + 20% kernel / faults: 24181 minor

  54% 4797/tlog: 2% user + 52% kernel / faults: 1 minor

  52% 1123/system_server: 17% user + 34% kernel / faults: 61367 minor

  38% 956/vendor.qti.hardware.display.composer-service: 12% user + 25% kernel / faults: 597 minor

  31% 1047/surfaceflinger: 14% user + 17% kernel / faults: 2537 minor

  3.3% 1329/media.codec: 1.2% user + 2.1% kernel / faults: 22526 minor

  7.6% 21256/com.android.settings: 5.1% user + 2.4% kernel / faults: 3298 minor

  6.9% 2941/com.hht.lebocast: 3% user + 3.9% kernel / faults: 1183 minor

  6.2% 1278/installd: 0.4% user + 5.8% kernel / faults: 23 minor

  6.1% 1403/media.swcodec: 1.2% user + 4.8% kernel / faults: 10764 minor

  5.2% 5417/com.sohu.inputmethod.sogou.car: 2.4% user + 2.8% kernel / faults: 2133 minor

  5.1% 3582/com.android.calendar: 2.5% user + 2.5% kernel / faults: 1650 minor

  5% 772/crtc_commit:125: 0% user + 5% kernel

...

日志见FTP：

ftp://cdiot@192.168.87.46/Pre_figure/Test_Log/Bug_113739/Tlog&#38;ANR.zip

#8 - 2022-11-15 10:40 - CD FW 曹覃刚

UserDebug版本运行Monkey跑出的问题，将在user版本上跑三个版本观察，如果不再复现，我们将关闭这个问题

#9 - 2022-11-16 11:12 - CD Test赵飞

11月15号Release版本（uer）未复现此问题
继续跟踪2个版本

#10 - 2022-11-16 19:42 - CDTS-TEST 周婷

- Due date deleted (2022-11-08)

- Target version changed from VX1_MCE_FSE_V3.0_update_20221130 to VX1_MCE_FSE_V5.0_20221230

#11 - 2022-11-18 10:55 - CD Test赵飞

- Status changed from ASSIGNED to RESOLVED

- % Done changed from 40 to 80

11月16号DB版本（user）及11月17号Release版本均未复现此问题

暂时关闭此问题

#12 - 2022-11-18 10:55 - CD Test赵飞

- Status changed from RESOLVED to VERIFIED

#13 - 2022-11-18 10:55 - CD Test赵飞

- Status changed from VERIFIED to CLOSED

- % Done changed from 80 to 100

Files

error.txt 1.81 MB 2022-11-01 CD Test赵飞

info.txt 3.71 MB 2022-11-01 CD Test赵飞

Tlog&ANR.zip.001 40 MB 2022-11-09 CD Test赵飞

Tlog&ANR.zip.002 40 MB 2022-11-09 CD Test赵飞

Tlog&ANR.zip.003 2.68 MB 2022-11-09 CD Test赵飞
